//******************************************************************************************************
// V12.06.2013  _16_LCD_julbo_u_horloge
// traitement des messages reçus 
// spécifique selon application, reception dans sp.h
// #include "msg_traitement.h"

    if (msg_recu > 0) {

// test de présence (watch dog)
      switch (msg[0]) {
      case '?':
        Serial << horodatage('d') << "ARDUINO " << version << " " << msg << endl;  
      break;

// if time sync available from serial port, update time and return true
// message = T08,09,10,11,12,13*         Thh,mm,ss,dd,mm,yy
//           1234567890123456789
      case 'T' :
        if (msg_recu == 18) {
//          time_t pctime = 0;
          j=1;
          for(i=0; i < 6; i++){
//            hmsdmy[i]=msg.parseInt();
            hmsdmy[i]=10*(msg[j]-'0'); j++;
            hmsdmy[i]=hmsdmy[i]+msg[j]-'0'; j += 2;
          }
          Serial << "ARDUINO T " << version << endl; 
          hmsdmy[0] = constrain(hmsdmy[0], 0, 23);
          hmsdmy[1] = constrain(hmsdmy[1], 0, 59);
          hmsdmy[2] = constrain(hmsdmy[2], 0, 59);
          hmsdmy[3] = constrain(hmsdmy[3], 1, 31);
          hmsdmy[4] = constrain(hmsdmy[4], 1, 12);
//          hmsdmy[5] = constrain(hmsdmy[5], 0, 99);
          setTime(hmsdmy[0],hmsdmy[1],hmsdmy[2],hmsdmy[3],hmsdmy[4],hmsdmy[5]); 
//          horodatage_serie('d'); Serial << "STOP ARDUINO T" << endl;  
// indicateur de synchro OK
          horloge_synchronisee = 1;
          horloge_synchro_tempo = horloge_synchro_tempo_reset;
        }
      break;
/*
http://fr.wikipedia.org/wiki/Heure_d'été

il est « midi (solaire) à quatorze heures (légales) » en été.
il est « midi (solaire) à treize heures (légales) » en hiver.

la période de l’heure d’été commence à 1 heure du matin, temps universel, le dernier dimanche de mars
la période de l’heure d’été se termine à 1 heure du matin, temps universel, le dernier dimanche d’octobre

*/
      
// T1262347200  //noon Jan 1 2010  ( secondes depuis le 01/01/1970
//  1261440000 sec/40 ans (le décalage donne 10 jours, soit bien 10 années bissextiles)
//       86400 sec/jour
//    31536000 sec/an
// T1293969600  //noon Jan 1 2011
// T1325505600  //noon Jan 1 2012
// T1357041600  //noon Jan 1 2013
// T1388577600  //noon Jan 1 2014 

// pour messages MUSIQUE ou MORSE ou AUTRES
// message = M................*
       case 'M':
#if lcdj > 0
        lcdj_clear('\0'); // RAZ des buffers
//        lcdj_affiche();
        j=min(msg_recu-1,sizeof(lcdj_buf));
#endif
// affichage
#if lcdj > 0
        for (i=0;i<j;i++) lcdj_buf[i]=msg[i+1];
        lcdj_tempo_b=lcdj_tempo_b_reset;
#endif
// envoi à CW
        if (grafcet_cw == 1) {
          if (debug >0) { horodatage_serial(); Serial << "ARDUINO Music|cw=" << msg << endl; }
          j=min(msg_recu-1,sizeof(cw_texte));
          for (i=0;i<j;i++) cw_texte[i]=msg[i+1];
//          strncpy(cw_texte,msg,j);
        }
        msg_recu=0;
      break;

// message affiché = A................*
      case 'A':
#if lcdj > 0
        lcdj_clear('\0'); // RAZ des buffers
//        lcdj_affiche();
        j=min(msg_recu-1,sizeof(lcdj_buf));
        for (i=0;i<j;i++) lcdj_buf[i]=msg[i+1];
        lcdj_tempo_b=lcdj_tempo_b_reset;
#endif
        if (debug ==0) { horodatage_serial(); Serial << "ARDUINO A=" << msg << endl; }
      break;

// message = X0/X1 AUTORISATION DE TRANSMISSION
      case 'X':       
//      if (msg[1] == '0' || msg[1] == '1') TX_autorisation=msg[1]-'0':
        if (grafcet_cw == 1) { strcpy(cw_texte,"OK"); }
        if (debug >0) { horodatage_serial(); Serial << "ARDUINO Xmit=" <<  msg[0] << endl; }
      break;

// message = D0/D1/D2...  DEBUG
      case 'D':  
        if (grafcet_cw == 1) {
          if (msg[1] >='0' && msg[1] <='9') { debug=msg[1]-'0'; strcpy(cw_texte,"abcc"); }
          if (debug >0) { horodatage_serial(); Serial << "ARDUINO Debug=" << debug << endl; }
        }
      break;

    }		// switch
    msg_recu=0;
  }    // msg_recu > 0
    
//******************************************************************************************************

