// ************************************************************************************************
// SOUS-PROGRAMMES V13.06.2013
// serial_reception : amélioré, fin de message = *
// http://www.cplusplus.com/reference/  Aide en C/C++
// ************************************************************************************************
/* Programme au -ieme de seconde, gestion des temporisations
 NB : le débordement du compteur en (unsigned long) a lieu tous les 50 jours environ ...
 lorsqu'il arrive à  la valeur 2^32-1 = 4294967295 = 49j 17h 2m 47s
 F1FWG : je ne sais ce qui se passe dans ces cas-là  ...
 delta devient négatif, euh non, très grand : 
 previousMillis = 4294967290
 millis() = 4294967290 + 10(par exemple) = 4294967300 (-4294967296)=> 4 
 delta = 4 - 4294967290 = ??? 
*/
void ger_top_centieme (){
  unsigned long delta;
  unsigned long currentMillis = millis();

// Top Millième de secondes
  delta = currentMillis - previous1;
  if (delta >= 1) {
    milliseconde += delta;
// save the last time you come here
    previous1 = currentMillis;   
    top_1 = delta;
  }

// Top Centième de secondes
  delta = currentMillis - previous10;
  if (delta >= 10) {
// save the last time you come here
    previous10 = currentMillis;   
    top_10 = delta;
  }

// Top Dixième de seconde
   delta = currentMillis - previous100;
   if (delta >= 100) {
    previous100 = currentMillis;   
    top_100ms = true;
    
// Top Seconde
    if (second() != previousSecond) {
      previousSecond = second();
      top_1000ms = true;
      milliseconde = 0;

// Top Minute
      if (previousSecond == 0) {
        top_60000ms=true;
        
// indicateur si horloge synchroniée
        if (horloge_synchro_tempo < 1) {
          horloge_synchro_tempo = horloge_synchro_tempo_reset;
//          horloge_synchronisee = 0;  // indique si la mise à  l'heure a été effectuée
        } else {
          horloge_synchro_tempo--;
        }
      }
    }
  }

// Top 250ms
   delta = currentMillis - previous250;
   if (delta >= 250) {
    previous250 = currentMillis;   
    top_250ms = true;
   
// Top 500ms
    delta = currentMillis - previous500;
     if (delta >= 500) {
       previous500 = currentMillis;   
       top_500ms = true;
     }
   }
  return;
}
// ************************************************************************************************
// affichage horloge dans un char
char* horodatage(char format) {
// 'c' centiemes/milliemes 15:28.584
// 'h' heure               10:15:28
// 'd' date et heure       01/04/2013 10:15:28
char out[30];
char valuef[5];

  memset (out,'\0',sizeof(out));
//                         12345678901234567890
// 'd' date et heure       01/04/2013 10:15:28_
// 'h' heure               10:15:28_
// 'c' centiemes/milliemes 15:28.584_
  if (format == 'd') {
    dtostrf(day(),2,0,valuef); strcpy( out, valuef ); strcat( out, "/" );
    dtostrf(month(),2,0,valuef); strcat( out, valuef ); strcat( out, "/" );
    dtostrf(year(),4,0,valuef); strcat( out, valuef ); strcat( out, " " );
    dtostrf(hour(),2,0,valuef); strcat( out, valuef ); strcat( out, ":" );
  }
  if (format == 'h') {
    dtostrf(hour(),2,0,valuef); strcpy( out, valuef ); strcat( out, ":" );
  }
//  if (format == 'd' || format == 'h' || format == 'c') {
    dtostrf(minute(),2,0,valuef);
    if (format == 'c') {strcpy( out, valuef );} else { strcat( out, valuef );}
    strcat( out, ":" );
    dtostrf(second(),2,0,valuef); strcat( out, valuef );
//  }
  if (format == 'c') {
    strcat( out, "." );
    dtostrf(milliseconde,3,0,valuef); strcat( out, valuef );
  }
  strcat( out, " \0" );
// rajout zeros  
int ii;
  for (ii=0;ii<sizeof(out)-3;ii++) {if (ii!= 10 && out[ii]==' ' && out[ii+1]!='\0') out[ii]='0'; }
// debug
//  Serial << "out=" << out << "=" << endl;  
  return out;
}

// affichage horloge sur la sortie serie, sans fin de ligne
void horodatage_serie(char format) {
   Serial << horodatage(format);
/*
  if (format == 'c') (minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "." << ((milliseconde<10)?"00":(milliseconde<100)?"0":"") << milliseconde << " ";
  if (format == 'h') Serial << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
  if (format == 'd') Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
*/
}

// affichage horloge sur la sortie serie, sans fin de ligne
void horodatage_serial() {
// heure seulement
 horodatage_serie('h');
//  Serial << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
// date et heure
//  Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << " ";
}

// ************************************************************************************************
// demande de mise à l'heure
/* 
  mettre dans le setup() :
// mise à l'heure
  setSyncInterval(290);         // set the number of seconds between re-sync
  setSyncProvider(getTimeFunction);  // set the external time provider
*/
time_t getTimeFunction () {
//  time_t x;
//  x=36000;  // récupérer l'heure quelquepart ... 
// on doit retourner l'heure récupérée, 0 si on la recoit plus tard par un autre moyen
  Serial << "HEURE SVP" << endl;
  return 0;  
}
// ************************************************************************************************
/* scrutation et filtrage de clavier analogique

  utilisation "monocoup" :
  if (touche == '1') { ...; touche=' ';}

  utilisation avec "répétition" :
  if (touche_repeat == '1') { ...; touche_repeat=' ';}
*/

void ger_scrute_clavier(){
// clavier - filtrage sur NO de touche (c'est plus stable que sur valeur)
  ntouche6 = ntouche5;
  ntouche5 = ntouche4;
  ntouche4 = ntouche3;
  ntouche3 = ntouche2;
  ntouche2 = ntouche1;
  ntouche1 = ntouche;

  itouche = analogRead(clavier);

    ntouche=-1;
    do {
      ntouche++;
    } while (itouche > ((xtouche[ntouche]+xtouche[ntouche+1])/2) && ntouche < nbtouche);
// OU en appliquant la formule n = ( valeur_ana + 20 ) / 41 on devrait récupérer le No de la touche de 0 à  9 ...

// TRACE pour calibrage
//  if (itouche < 1000 ) Serial << itouche << "=" << ntouche << endl;

// si la touche est stable (X tours)
  if (ntouche==ntouche1 && ntouche==ntouche2 && ntouche==ntouche3 && ntouche==ntouche4 && ntouche==ntouche5 && ntouche==ntouche6) {

// si la touche a varié
    if (ltouche[ntouche] != vtouche ) {
//    if (itouche < 1000 ) Serial << itouche << "=" << ntouche << endl;
      vtouche = ltouche[ntouche];
// touche valide
      if (ntouche < nbtouche) { 
        touche = vtouche;
        touche_repeat = vtouche;
        tempo_repeat=800;  // duree avant repetition
// arret répétition
      } else {
        touche_repeat = ' ';
      }
// si la touche est la màªme : repeat ?
    } else {
      if (ntouche < nbtouche && tempo_repeat == 0 ) {
        touche_repeat = vtouche;
        tempo_repeat=500;  // vitesse repetition
      }
    }
// debug
//  } else {
//  Serial << itouche6 << " " << itouche5 << " " << itouche4 << " " << itouche3 << " " << itouche2 << " " << itouche1 << " " << itouche << endl;
  }
  return;
}

// ************************************************************************************************

/*
Convertit  la valeur 'float' "v" avec "nbchiffres" digits significatifs suivi de l'"unite"
Donc "nbchiffres" digits + point + multiplicateur + unite = "nbchiffres+3" caractères
Résultat dans 'buf'.
Usage :
char valuef[15];
    freq=123456.789;    formatf(freq,'c',5,valuef); // valuef="123.45Kc\0"
    freq=1.23456789;    formatf(freq,'c',8,valuef); // valuef="1.2345678c \0"
    Serial << "F=" << valuef;                       // sur voie série
    lcd.setCursor(0, 0);  lcd << "F=" << valuef;    // sur LCD
    strcpy(cw_texte,valuef);                        // en MORSE
*/
void formatf(float v,char unite,int nbchiffres,char buf[15])
{
//      dtostrf(floatVar, minStringWidthIncDecimalPoint, numVarsAfterDecimal, charBuf);

 float vloc;
 int mult=5,nbdec;
//   mult =            0    1    2    3    4    5   6     7     8    9
//   multiplicateur =  Peta Tera Giga Mega Kilo 1   milli micro nano pico
 char multiple[10] = {'P', 'T', 'G', 'M', 'k', ' ','m',  'u',  'n', 'p'};
  vloc=v;
// si =0.000000, on garde mult=5
  if (vloc != 0.0) {
// si valeur inférieure à 1, on multiplie
    while (vloc < 1. && mult < 9) {
      vloc = vloc*1000;
      mult++;
    }
// si valeur grande, on divise
    while (vloc >= 1000. && mult > 0) {
      vloc = vloc/1000;
      mult--;
    }
  }
// nombre de décimales selon valeur   // ex nbchiffres=4    7
   nbdec = nbchiffres-1;              //           9.999  9.999999
   if (vloc > 10 ) nbdec--;           //           99.99  99.99999
   if (vloc > 100 ) nbdec--;          //           999.9  999.9999
// conversion FLOAT CHAR
   dtostrf(vloc,nbchiffres,nbdec,buf);
// ici, nbdec devient la longueur obtenue (rien à voir avec le nombre de décimales)
   nbdec=strlen(buf);
   if (mult!=5) {
      buf[nbdec]=multiple[mult]; buf[nbdec+1]=unite;
   } else {
      buf[nbdec]=unite; buf[nbdec+1]=multiple[mult];
   }
// fin de CHAR
   buf[nbdec+2]='\0';
//   Serial << "*buf=" << buf << "*l=" << strlen(buf) << "*" << endl;
   return;
}
// ************************************************************************************************
// traitement de reception sur le port Serial
// synchro de l'horloge :
void serial_reception() {
 int hmsdmy[6];
int i,j,k;
#define msg_size 30
  static char msg[msg_size]; 
  static int jmsg,msg_recu;

// reception message se terminant par LF ou CR ou *
   j=Serial.available();
   if (j > 0) {
     if (jmsg < 0 || jmsg>msg_size) jmsg=0;
// récupération de tous les caractères disponibles
     for (i=0;i<j;i++) {
       msg[jmsg] = Serial.read();
// fin de message
       if (msg[jmsg] == '*' || msg[jmsg] == 0x0A || msg[jmsg] == 0x0D) {
         if (msg[jmsg] == 0x0A || msg[jmsg] == 0x0D) msg[jmsg] = '*';
         for (k=jmsg+1;k<msg_size;k++) msg[k] == '\0';
//         Serial << " jmsg=" << jmsg << " <" << _HEX(msg[jmsg]) << ">" << endl;  
          msg_recu=jmsg;         jmsg=0;
/*
       Serial << "*recu=" << msg_recu << " HEX=" << _HEX(msg[msg_recu]) << " [";
       for (k=0;k<=msg_recu;k++)  Serial << msg[k];  
       Serial << "]" << msg << "<" << endl;  
*/
// on pointe sur le suivant
       } else {
         jmsg++; if (jmsg>=msg_size) jmsg=0;
       }
     }
   }
   
// TRAITEMENT DES MESSAGES RECUS
#include "msg_traitement.h"
        
}
// T1262347200  //noon Jan 1 2010  ( secondes depuis le 01/01/1970
//  1261440000 sec/40 ans (le décalage donne 10 jours, soit bien 10 années bissextiles)
//       86400 sec/jour
//    31536000 sec/an
// T1293969600  //noon Jan 1 2011
// T1325505600  //noon Jan 1 2012
// T1357041600  //noon Jan 1 2013
// T1388577600  //noon Jan 1 2014 
// ************************************************************************************************
/*
Convertit la valeur 'float' "v" avec "nbchiffres" digits significatifs suivi de l'"unite"
Donc "nbchiffres" caractères
Résultat dans 'buf'.
Usage :
char valuef[15];
    freq=123456.789;    formati(freq,'c',6,valuef); // valuef="123456\0"
    freq=12.3456789;    formati(freq,'c',8,valuef); // valuef="       12\0"
    Serial << "F=" << valuef;                       // sur voie série
    lcd.setCursor(0, 0);  lcd << "F=" << valuef;    // sur LCD
    strcpy(cw_texte,valuef);                        // en MORSE
*/
/*
void formati(int v,int nbchiffres,char buf[15])
{
//      dtostrf(floatVar, minStringWidthIncDecimalPoint, numVarsAfterDecimal, charBuf);

 float vloc;
  vloc=v;
   if (vloc < pow(10,nbchiffres)) nbdec++;          //           99.99  99.99999
   if (vloc < 10 ) nbdec++;          //           9.999  9.999999
// conversion FLOAT CHAR
   dtostrf(vloc,nbchiffres,nbdec,buf);
// ici, nbdec devient la longueur obtenue (rien à  voir avec le nombre de décimales)
   nbdec=strlen(buf);
   if (mult!=5) {
     buf[nbdec+1]=unite; buf[nbdec]=multiple[mult];
   } else {
     buf[nbdec]=unite; buf[nbdec+1]=multiple[mult];
   }
// fin de CHAR
   buf[nbdec+2]='\0';
//   Serial << "*buf=" << buf << "*l=" << strlen(buf) << "*" << endl;
   return;
}
*/
// ************************************************************************************************
// pour transférer des données entre 2 buffers, avec décalage des débuts
/* exemples :
int buff_transfert (entree, 0, 10, sortie, 0, 10)
        sortie = ................
        entree = ABCDEFGHIJKLMNOP     
        sortie = ABCDEFGHIJ......
//               0123456789012345
int buff_transfert (entree, 4, 6, sortie, 0, 5)
        sortie = ................
        entree = ABCDefghijKLMNOP     
        sortie = efghi...........
//               0123456789012345
int buff_transfert (entree, 4, 6, sortie, 2, 5)
        sortie = ................
        entree = ABCDefghijKLMNOP     
        sortie = ..efghi.........
//               0123456789012345
//
//  buff_transfert (socketrecp, 4, socketrecp_ok, busp_fifo[busp_fifo_in].trame, 5, 16);
*/
int buff_transfert (char* entree, int debut, int longueur, char* slot, int slotdebut, int nb_maxi) {
      int l,j;
// "longueur_maxi" est le nombre maximal de caractères admis par "slot"
   l = longueur-debut; if (l > nb_maxi) { l = nb_maxi; }
   if (l > 0) {
// copie "longueur" caractères de "entree" dans "slot"
      for (j = 0; j < l; j++) { slot[j+slotdebut] = entree[j+debut];  }
      return true;
// rien à faire
      } else {
      return false;
   }
}
//==============================================================================
int asc2tob(int asc1,int asc0)
// transforme 2 octets ASCII 00..FF en valeur numérique 0-255
{
// Convert lowercase to uppercase
   if(asc1 > 'F') asc1 -= 'a'-'A';
   if(asc0 > 'F') asc0 -= 'a'-'A';

// Convert only 0-F
//   if((asc1 > '9' || asc1 < '0') && (asc1 > 'F' || asc1 < 'A')) asc1 = '0'; 
//   if((asc0 > '9' || asc0 < '0') && (asc0 > 'F' || asc0 < 'A')) asc0 = '0'; 

// Convert 0-9, A-F to 0x0-0xF
   if(asc1 > '9') 
      asc1 -= 'A' - 10;
   else
      asc1 -= '0';

   if(asc0 > '9') 
      asc0 -= 'A' - 10;
   else
      asc0 -= '0';

// Convert only 0x0-0xF
   if(asc1 > 0x0F || asc1 < 0) asc1 = 0; 
   if(asc0 > 0x0F || asc0 < 0) asc0 = 0; 

// Concatenate
   return (asc1<<4) |  asc0;
}
// ************************************************************************************************
/*
// modules pour debug sérieux !
void horodatage_serie(char format) ;
void serial_alarme(int no,int value,int mini, int maxi) {
  if (value < mini || value > maxi) { horodatage_serie('h'); Serial << " ALARME No" << no << " " << mini << "!<" << value << "<!" << maxi << endl;}
}
*/
// ************************************************************************************************
// ARCHIVES, NOTES ...
// ************************************************************************************************
/*
// AUTRES CONVERSIONS
char* dtostrf  ( double  __val,  
  signed char  __width,  
  unsigned char  __prec,  
  char *  __s  
 ) 
 
 char* itoa  ( int  __val,  
  char *  __s,  
  int  __radix  
 ) 

char* ltoa  ( long int  __val,  
  char *  __s,  
  int  __radix  
 ) 

dtostrf(vloc,nbchiffres,nbdec,cw_texte);
   nbdec=strlen(cw_texte);
   cw_texte[nbdec]=multiple[mult];
   cw_texte[nbdec+1]=unite;
   cw_texte[nbdec+2]='\0';
   }
*/
/*
// Transforme la date et l'heure "lisible" en format UNIX pour mise à  l'heure et date
time_t setupArduinoTime(int y,int m, int j, int h, int mi, int se) {
  tmElements_t tm;
  tm.Year = y-1970;
  tm.Month = m;
  tm.Day = j;
  tm.Hour = h;
  tm.Minute = mi;
  tm.Second = se;
  time_t time = makeTime(tm);
  return time;
}
//+ voici le s/p original qui provient d'une bibliothèque pour GPS :
time_t gpsTimeToArduinoTime(){
// returns time_t from gps date and time with the given offset hours
  tmElements_t tm;
  int year;
  gps.crack_datetime(&year, &tm.Month, &tm.Day, &tm.Hour, &tm.Minute, &tm.Second, NULL, NULL);
  time_t time = makeTime(tm);
  return time + (offset * SECS_PER_HOUR);
}
*/
// ************************************************************************************************
// ************************************************************************************************



