#define version "16 LCD jumbo simple"
//
/******************/
// ENTREES SORTIES

// variables diverses
int i2,j2;

//**********************************************************
// déclarations et sous-programmes pour le LCD JUMBO
#include "lcd_jumbo.h"

//**********************************************************
// INITIALISATIONS

void setup() {

// ligne série (pour traces)
  Serial.begin(9600);  // selon votre port COM
  Serial.println (version);

//Définition des e/s
  pinMode(lcdj_0, OUTPUT);
  pinMode(lcdj_1, OUTPUT);
  pinMode(lcdj_2, OUTPUT);
  pinMode(lcdj_3, OUTPUT);
  pinMode(lcdj_CS1, OUTPUT);
  pinMode(lcdj_WE, OUTPUT);

// potentiomètre
  pinMode(A0, INPUT);

// initialisation du LCD
   lcdj_init();
// laisser voir tout allumé 2 sec.
   lcdj_affiche();
   Serial.println ("tout allum\xE9");
   delay(2000);
}

//////////////////////////////////////////////////////////////////////////////////////////////
void loop() {

// tout éteindre
   memset (lcdj_buf,' ',sizeof(lcdj_buf));
   lcdj_affiche();
   Serial.println ("tout \xE9teint");

// affichage demo 123456......
   Serial.println ("d\xE9mo");
   i2=0;
   for (j2=0;j2<lcdj_seg_nb;j2++) {
    lcdj_buf[i2]=lcdj_seg[j2].c;
    i2++; if (i2>=6) i2=0;
// affichage lcd JUMBO
    lcdj_affiche();
// attente
    delay (300);
  }

// affichage valeur du potentiometre tant qu'il n'est pas à 0
    i2=1;
    while (i2>0) {
        i2=(3*j2+analogRead(A0))/4;    // filtrage
        if (i2 != j2) {
// conversion FLOAT CHAR
          dtostrf (i2,6,0,lcdj_buf); strcat( lcdj_buf, "        " );
          if (i2 > j2) {lcdj_buf[0]='+';} else {lcdj_buf[0]='_';}    // + ou -
          j2=i2;     // mémoire
          Serial.print ("potentiom\xE8tre="); Serial.println (j2);
	} else {
          lcdj_buf[0]='-';
        }
// affichage lcd JUMBO
        lcdj_affiche();
// attente
        delay (100);
    }
		
//--------------------------------********************--------------------------------
} // fin loop()
//--------------------------------********************--------------------------------

