#define version "16 LCD jumbo triple"
//
#include <Streaming.h>

/******************/
// ENTREES SORTIES

// variables diverses
int i,i2,j2;

//**********************************************************
// déclarations et sous-programmes pour le LCD JUMBO
// voir dans ce .h les paramètres tels les entrées-sorties, le nombre de modules ...
#include "lcd_jumbo.h"

//**********************************************************
// INITIALISATIONS

void setup() {

// ligne série (pour traces)
  Serial.begin(9600);  // selon votre port COM
  Serial.println (version);

// Forcage pour essayer sans CS géré ou avec moins de modules (selon lcdjx)
#if lcdjx < 1
 pinMode(37, OUTPUT);
 digitalWrite(37,LOW);
#endif
#if lcdjx < 2
 pinMode(38, OUTPUT);
 digitalWrite(39,LOW);
#endif
#if lcdjx < 3
 pinMode(39, OUTPUT);
 digitalWrite(38,LOW);
#endif

// potentiomètre
  pinMode(A0, INPUT);

// initialisation du LCD jumbo
   lcdj_init();
}

//////////////////////////////////////////////////////////////////////////////////////////////
void loop() {

// affichage demo de tous les caractères
//   Serial << "d\xE9mo" << endl;
   for (j2=0;j2<(lcdj_seg_nb-(lcdj*lcdj_nbd));j2++) {
    for (i2=0;i2<(lcdj*lcdj_nbd);i2++) {
      lcdj_buf[i2]=lcdj_seg[j2+i2].c;
// affichage lcd JUMBO
      lcdj_affiche();
    }
//    Serial << j2 << "=j2 lcdj_buf=" << lcdj_buf << "=" << endl;
// attente
    delay (100);
    if (lcdjx < 3) delay (100);
    if (lcdjx < 2) delay (100);
    if (lcdjx < 1) delay (100);
  }

// affichage valeur du potentiometre tant qu'il n'est pas à 0, avec bar-graphe
    i2=1;
    while (i2>0) {
        i2=(3*j2+analogRead(A0))/4;    // filtrage
        if (i2 != j2) {
// conversion FLOAT CHAR
          dtostrf (i2,5,0,lcdj_buf); 
// bargraphe
          if (lcdj > 1) {
            for (i=5;i<lcdj_nbd*lcdj;i++) lcdj_buf[i]=' ';
            for (i=0;i<(j2*lcdj_nbd*lcdj/1020);i++) lcdj_buf[6+i]='o'; // lcdj_seg[lcdj_seg_nb-1].c ;//'°'; 
          }          
          if (i2 > j2) {lcdj_buf[0]='+';} else {lcdj_buf[0]='_';}    // + ou -
          j2=i2;     // mémoire
//          Serial << "potentiom\xE8tre=" << j2 << endl;
	} else {
          lcdj_buf[0]='-';
        }
// affichage lcd JUMBO
        lcdj_affiche();
// attente
        delay (100);
        
// T08,09,10,11,12,13*
/*
#define msg_size 30
  static char msg[msg_size]; 
  static int jmsg,msg_recu;
  int j,k;
// reception message se terminant par LF ou CR ou *
   j=Serial.available();
   if (j > 0) {
     if (jmsg < 0 || jmsg>msg_size) jmsg=0;
// récupération de tous les caractères disponibles
     for (i=0;i<j;i++) {
       msg[jmsg] = Serial.read();
// fin de message
       if (msg[jmsg] == '*' || msg[jmsg] == 0x0A || msg[jmsg] == 0x0D) {
         if (msg[jmsg] == 0x0A || msg[jmsg] == 0x0D) msg[jmsg] = '*';
         for (k=jmsg+1;k<msg_size;k++) msg[k] == '$';
//         Serial << " jmsg=" << jmsg << " <" << _HEX(msg[jmsg]) << ">" << endl;  
          msg_recu=jmsg;         jmsg=0;
       Serial << "*recu=" << msg_recu << " HEX=" << _HEX(msg[msg_recu]) << " [";
       for (k=0;k<=msg_recu;k++)  Serial << msg[k];  
       Serial << "]" << msg << "<" << endl;  

// on pointe sur le suivant
       } else {
         jmsg++; if (jmsg>msg_size) jmsg=0;
       }
     }
   }
*/   

   }  // while i2
		
//--------------------------------********************--------------------------------
} // fin loop()
//--------------------------------********************--------------------------------

